/* $Id:$ */


#include "bittoggles.h"
#include "bittoggles.c"

void test_bittoggles_lib(void);

btoggles_t bits;

int main(void) {
	test_bittoggles_lib();
}

/* #test bittoggles.c####################################################### */
void test_bittoggles_lib(void) {

	bits = 0x00000000;

	/* test set_sw */
	__builtin_printf("testing set_sw()\n");
	unsigned int i, j=0;
	/* for 0eth bit */
	set_sw(1<<j, &bits);
	j++;
	print_toggles("", &bits);
	/* for 1eth to 32nd bit */
	for(i=1;i<=31;i++, j++) {
		set_sw(1<<j, &bits);
		print_toggles("", &bits);
	}

	/* test unset_sw */
	__builtin_printf("testing unset_sw()\n");
	j=0;
	/* for 0eth bit */
	unset_sw(1<<j, &bits);
	j++;
	print_toggles("", &bits);
	/* for 1eth to 32nd bit */
	for(i=1;i<=31;i++, j++) {
		unset_sw(1<<j, &bits);
		print_toggles("", &bits);
	}

	/* test set_mask */
	__builtin_printf("testing set_mask()\n");
	set_mask(0xaaaaaaaa, &bits);
	print_toggles("", &bits);
	set_mask(0x55555555, &bits);
	print_toggles("", &bits);

	/* test unset_mask */
	__builtin_printf("testing unset_mask()\n");
	unset_mask(0xaaaaaaaa, &bits);
	print_toggles("", &bits);
	unset_mask(0x55555555, &bits);
	print_toggles("", &bits);

	/* test true_mask */
	__builtin_printf("testing true_mask()\n");
	set_mask(0xffffffff, &bits);
	if(true_mask(0xaaaaaaaa, &bits)) /* is entire set true */
		print_toggles("", &bits);
	bits = 0x55555555;
	if(!true_mask(0xaaaaaaaa, &bits)) /* is there a false in set(all false) */
		print_toggles("", &bits);
	bits = 0xfffffffe;
	if(!true_mask(0xffffffff, &bits)) /* is there a false in set(one false) */
	print_toggles("", &bits);
	bits = 0;

	/* test test_sw */
	__builtin_printf("testing test_sw()\n");
	set_mask(0xaaaaaaaa, &bits);
	print_toggles("", &bits);
	/* using test logic, invert all bits
	   for 0eth bit */
	j=0;
	if(test_sw(1<<j, &bits)) {
		unset_sw(1<<j, &bits);
	} else {
		set_sw(1<<j, &bits);
	}
	j++;
	/* for 1eth to 32nd bit */
	for(i=1;i<=31;i++, j++) {
		if(test_sw(1<<j, &bits)) {
			unset_sw(1<<j, &bits);
		} else {
			set_sw(1<<j, &bits);
		}
	}
	print_toggles("", &bits);
	/* using test logic, invert all bits again
	   for 0eth bit */
	j=0;
	if(test_sw(1<<j, &bits)) {
		unset_sw(1<<j, &bits);
	} else {
		set_sw(1<<j, &bits);
	}
	j++;
	/* for 1eth to 32nd bit */
	for(i=1;i<=31;i++, j++) {
		if(test_sw(1<<j, &bits)) {
			unset_sw(1<<j, &bits);
		} else {
			set_sw(1<<j, &bits);
		}
	}
	print_toggles("", &bits);


	/* pointer versions
	   test set_sw_p */
	unsigned int k;
	bits = 0x00000000;
	__builtin_printf("\ntesting set_sw_p()\n");
	j=0;
	/* for 0eth bit */
	k=1<<j;
	set_sw_p(&k, &bits);
	j++;
	print_toggles("", &bits);
	/* for 1eth to 32nd bit */
	for(i=1;i<=31;i++, j++) {
		k=1<<j;
		set_sw_p(&k, &bits);
		print_toggles("", &bits);
	}

	/* test unset_sw_p */
	__builtin_printf("testing unset_sw_p()\n");
	j=0;
	/* for 0eth bit */
	k=1<<j;
	unset_sw_p(&k, &bits);
	j++;
	print_toggles("", &bits);
	/* for 1eth to 32nd bit */
	for(i=1;i<=31;i++, j++) {
		k=1<<j;
		unset_sw_p(&k, &bits);
		print_toggles("", &bits);
	}

	/* test set_mask_p */
	__builtin_printf("testing set_mask_p()\n");
	unsigned int mask1 = 0xaaaaaaaa;
	unsigned int mask2 = 0x55555555;
	set_mask_p(&mask1, &bits);
	print_toggles("", &bits);
	set_mask_p(&mask2, &bits);
	print_toggles("", &bits);

	/* test unset_mask_p */
	__builtin_printf("testing unset_mask_p()\n");
	unset_mask_p(&mask1, &bits);
	print_toggles("", &bits);
	unset_mask_p(&mask2, &bits);
	print_toggles("", &bits);

	/* test true_mask_p */
	btoggles_t temp;
	__builtin_printf("testing true_mask_p()\n");
	set_mask(0xffffffff, &bits);
	temp=0xaaaaaaaa;
	if(true_mask_p(&temp, &bits)) /* is entire set true */
		print_toggles("", &bits);
	bits = 0x55555555;
	temp=0xaaaaaaaa;
	if(!true_mask_p(&temp, &bits)) /* is there false in set(all false) */
		print_toggles("", &bits);
	bits=0xfffffffe;
	temp=0xffffffff;
	if(!true_mask_p(&temp, &bits)) /* is there a false in set(one false) */
		bits = 0x1;
	print_toggles("", &bits);
	bits = 0;

	/* test test_sw_p */
	__builtin_printf("testing test_sw_p()\n");
	set_mask(0xaaaaaaaa, &bits);
	print_toggles("", &bits);
	/* using test logic, invert all bits
	   for 0eth bit */
	j=0;
	k=1<<j;
	if(test_sw_p(&k, &bits)) {
		unset_sw(1<<j, &bits);
	} else {
		set_sw(1<<j, &bits);
	}
	j++;
	/* for 1eth to 32nd bit */
	for(i=1;i<=31;i++, j++) {
		k=1<<j;
		if(test_sw_p(&k, &bits)) {
			unset_sw(1<<j, &bits);
		} else {
			set_sw(1<<j, &bits);
		}
	}
	print_toggles("", &bits);
	/* using test logic, invert all bits again
	   for 0eth bit */
	j=0;
	k=1<<j;
	if(test_sw_p(&k, &bits)) {
		unset_sw(1<<j, &bits);
	} else {
		set_sw(1<<j, &bits);
	}
	j++;
	/* for 1eth to 32nd bit */
	for(i=1;i<=31;i++, j++) {
		k=1<<j;
		if(test_sw_p(&k, &bits)) {
			unset_sw(1<<j, &bits);
		} else {
			set_sw(1<<j, &bits);
		}
	}
	print_toggles("", &bits);
}
/* ######################################################################### */

